#include <string.h>
#include <stdlib.h>
#include "ctype.h"
#include "vldtn.h"
#include "helper.h"
#include "vmacros.h"

#define TRUE 1

#define Year1 2008
#define Year2 2009
#define December1YearPre1 "01/12/2007"
#define August1YearPre1 "01/08/2007"
#define August1YearPre14 "01/08/1994"
#define August1Year1 "01/08/2008"
#define December1Year1 "01/12/2008"
#define August1Year2 "01/08/2009"
#define December1Year2 "01/12/2009"
#define Jul1PreYr13 "01/07/1995"
#define Dec1PreYr10 "01/12/1998"
#define August1Year3 "01/08/2010"
int uiNeedsPostcode=0;
int uiNeedsJACScode=1;
SZ szVRVer[]="1.5";
SZ szDateWritten[]="2009-08-25 11:07:01";

#ifdef ANSI
static UINT ValidateField1(void);
static UINT FieldInfo1(int bMacro);
static UINT ValidateField2(void);
static UINT FieldInfo2(int bMacro);
static UINT ValidateField3(void);
static UINT FieldInfo3(int bMacro);
static UINT ValidateField4(void);
static UINT FieldInfo4(int bMacro);
static UINT ValidateField5(void);
static UINT FieldInfo5(int bMacro);
static UINT ValidateField6(void);
static UINT FieldInfo6(int bMacro);
static UINT ValidateField7(void);
static UINT FieldInfo7(int bMacro);
static UINT ValidateField8(void);
static UINT FieldInfo8(int bMacro);
static UINT ValidateField9(void);
static UINT FieldInfo9(int bMacro);
static UINT ValidateField10(void);
static UINT FieldInfo10(int bMacro);
#else
static UINT ValidateField1();
static UINT FieldInfo1();
static UINT ValidateField2();
static UINT FieldInfo2();
static UINT ValidateField3();
static UINT FieldInfo3();
static UINT ValidateField4();
static UINT FieldInfo4();
static UINT ValidateField5();
static UINT FieldInfo5();
static UINT ValidateField6();
static UINT FieldInfo6();
static UINT ValidateField7();
static UINT FieldInfo7();
static UINT ValidateField8();
static UINT FieldInfo8();
static UINT ValidateField9();
static UINT FieldInfo9();
static UINT ValidateField10();
static UINT FieldInfo10();
#endif

struct FLD stFields[]={
	{1,"RECID",0,5,0,1,ValidateField1,FieldInfo1,0,0,NULL,0},
	{2,"INSTID",1,4,5,1,ValidateField2,FieldInfo2,0,0,NULL,0},
	{3,"INSTGRAD",1,10,9,1,ValidateField3,FieldInfo3,0,0,NULL,0},
	{4,"GRADNAM",1,60,19,1,ValidateField4,FieldInfo4,0,0,NULL,0},
	{5,"MINSPINE",1,3,79,1,ValidateField5,FieldInfo5,0,0,NULL,0},
	{6,"CONSPINE",1,3,82,1,ValidateField6,FieldInfo6,0,0,NULL,0},
	{7,"MAXSPINE",1,3,85,1,ValidateField7,FieldInfo7,0,0,NULL,0},
	{8,"MINSAL",1,7,88,1,ValidateField8,FieldInfo8,0,0,NULL,0},
	{9,"CONSAL",1,7,95,1,ValidateField9,FieldInfo9,0,0,NULL,0},
	{10,"MAXSAL",1,7,102,1,ValidateField10,FieldInfo10,0,0,NULL,0},
	};


struct ERROR stErrors[]={
	{1,385,99,0},
	{2,386,99,0},
	{3,655,99,0},
	{3,658,99,0},
	{3,408,99,0},
	{4,410,99,0},
	{5,412,99,0},
	{5,411,99,0},
	{6,558,99,0},
	{6,557,99,0},
	{6,556,99,0},
	{6,666,99,0},
	{7,559,99,0},
	{7,667,99,0},
	{7,561,99,0},
	{7,668,99,0},
	{7,669,99,0},
	{8,650,99,0},
	{8,651,9,0},
	{8,562,99,0},
	{9,672,99,0},
	{9,670,99,0},
	{9,673,99,0},
	{9,568,99,0},
	{9,566,99,0},
	{10,675,99,0},
	{10,572,9,0},
	{10,676,99,0},
	{10,569,99,0},
	{10,571,99,0},
	{10,674,99,0},
	};

UINT uiRNo=27;
SZ szLRNo[]="08027";
UINT uiRLength=109;
UINT uinFields=10;
UINT uinRules=31;
UINT uiSeverity=0;
SZ szValidFile[]="08027va.csv";
SZ szErrorFile[]="08027.err";
SZ szBinFile[]="08027.bin";
SZ szError1File[]=".ERRORS";
SZ szLongDescFile[]=".RULES";
SZ szWarningFile[]=".WARNINGS";
SZ szTotalsFile[]=".SUMMARY";
SZ szInfoFile[]=".INF";
SZ szExplanErrFile[]="08027rl.csv";
UINT uiKeyField=2;

#define _RECID_ 0
#define _INSTID_ 1
#define _INSTGRAD_ 2
#define _GRADNAM_ 3
#define _MINSPINE_ 4
#define _CONSPINE_ 5
#define _MAXSPINE_ 6
#define _MINSAL_ 7
#define _CONSAL_ 8
#define _MAXSAL_ 9
int OwnStuId = 1;
int OwnPsdId = 1;


#ifdef ANSI
static UINT FieldInfo1(int bMacro)
#else 
static UINT FieldInfo1(bMacro)
int bMacro;
#endif 
{
if (!bMacro) {	return TRUE;
}
return 0;
}

#ifdef ANSI
static UINT ValidateField1(void)
#else 
static UINT ValidateField1()
#endif 
{
uiSeverity=0;
if ((!(M_ISFIELD(uiCurFieldNo, "08027"))) && (!IgnoreRule(385))) {
	uiSeverity=99;
	strcpy(RuleText,"RECID must contain 08027");
	return 385;
	}
return 0;
}

#ifdef ANSI
static UINT FieldInfo2(int bMacro)
#else 
static UINT FieldInfo2(bMacro)
int bMacro;
#endif 
{
if (!bMacro) {	return TRUE;
}
return 0;
}

#ifdef ANSI
static UINT ValidateField2(void)
#else 
static UINT ValidateField2()
#endif 
{
uiSeverity=0;
if ((!(M_VALIDCODE)) && (!IgnoreRule(386))) {
	uiSeverity=99;
	strcpy(RuleText,"INSTID must contain a valid current HESA HE institution identifier (see coding manual for all valid entries)");
	return 386;
	}
return 0;
}

#ifdef ANSI
static UINT FieldInfo3(int bMacro)
#else 
static UINT FieldInfo3(bMacro)
int bMacro;
#endif 
{
if (!bMacro) {	return TRUE;
}
return 0;
}

#ifdef ANSI
static UINT ValidateField3(void)
#else 
static UINT ValidateField3()
#endif 
{
uiSeverity=0;
if ((!(IsValidAlphanum(uiCurFieldNo,1,10) && !(M_ISFIELDN(uiCurFieldNo," ",0,1)))) && (!IgnoreRule(408))) {
	uiSeverity=99;
	strcpy(RuleText,"INSTGRAD must contain valid alphanumeric characters up to the maximum length specified, and the first character must not be a space.");
	return 408;
	}
if ((!(!(M_ISFIELD(uiCurFieldNo,"400")) &&
!(M_ISFIELD(uiCurFieldNo,"410")) &&
!(M_ISFIELD(uiCurFieldNo,"420")) &&
!(M_ISFIELD(uiCurFieldNo,"430")) &&
!(M_ISFIELD(uiCurFieldNo,"500")) &&
!(M_ISFIELD(uiCurFieldNo,"510")) &&
!(M_ISFIELD(uiCurFieldNo,"520")) &&
!(M_ISFIELD(uiCurFieldNo,"900")) &&
!(M_ISFIELD(uiCurFieldNo,"XXXXXXXXXX")))) && (!IgnoreRule(655))) {
	uiSeverity=99;
	strcpy(RuleText,"INSTGRAD must not contain 400, 410, 420, 430, 500, 510, 520, 900 or XXXXXXXXXX.");
	return 655;
	}
if ((!((
!M_ISFIELD(_MINSPINE_,"XXX") && !M_ISFIELD(_MAXSPINE_,"XXX") 
)
 ||
(
!M_ISFIELD(_MINSAL_,"XXXXXXX")  &&
!M_ISFIELD(_MAXSAL_,"XXXXXXX")
)
||
(
!M_ISFIELD(_MINSPINE_,"XXX")  &&
!M_ISFIELD(_MAXSAL_,"XXXXXXX")
))) && (!IgnoreRule(658))) {
	uiSeverity=99;
	strcpy(RuleText,"For every INSTGRAD there must be values other than Xs in (MINSPINE and MAXSPINE) or (MINSAL and MAXSAL) or (MINSPINE and MAXSAL) else error.");
	return 658;
	}
return 0;
}

#ifdef ANSI
static UINT FieldInfo4(int bMacro)
#else 
static UINT FieldInfo4(bMacro)
int bMacro;
#endif 
{
if (!bMacro) {	return TRUE;
}
return 0;
}

#ifdef ANSI
static UINT ValidateField4(void)
#else 
static UINT ValidateField4()
#endif 
{
uiSeverity=0;
if ((!(IsValidAlphanum(uiCurFieldNo,1,60))) && (!IgnoreRule(410))) {
	uiSeverity=99;
	strcpy(RuleText,"GRADNAM must contain valid alphanumeric characters up to the maximum length specified.");
	return 410;
	}
return 0;
}

#ifdef ANSI
static UINT FieldInfo5(int bMacro)
#else 
static UINT FieldInfo5(bMacro)
int bMacro;
#endif 
{
if (!bMacro) {	return TRUE;
}
return 0;
}

#ifdef ANSI
static UINT ValidateField5(void)
#else 
static UINT ValidateField5()
#endif 
{
uiSeverity=0;
if ((!((
M_ISFIELDN(uiCurFieldNo,"F",0,1) && 
IsFormat(uiCurFieldNo,"Cnn") && 
M_STRCMP(M_GETFIELDN(uiCurFieldNo,1,2),"01")>=0 && M_STRCMP(M_GETFIELDN(uiCurFieldNo,1,2),"51")<=0
) || M_ISFIELD(uiCurFieldNo,"XXX"))) && (!IgnoreRule(411))) {
	uiSeverity=99;
	strcpy(RuleText,"MINSPINE must contain a valid code (F01 - F51) from the Framework Salary Spine or XXX");
	return 411;
	}
if ((!(M_ISFIELD(uiCurFieldNo,"XXX") || M_ISFIELD(_MAXSPINE_,"XXX") ? M_TRUE : GetFieldNoIntegerMid(uiCurFieldNo,1,2) <= GetFieldNoIntegerMid(_MAXSPINE_,1,2))) && (!IgnoreRule(412))) {
	uiSeverity=99;
	strcpy(RuleText,"MINSPINE must be less than or equal to MAXSPINE");
	return 412;
	}
return 0;
}

#ifdef ANSI
static UINT FieldInfo6(int bMacro)
#else 
static UINT FieldInfo6(bMacro)
int bMacro;
#endif 
{
if (!bMacro) {	return TRUE;
}
return 0;
}

#ifdef ANSI
static UINT ValidateField6(void)
#else 
static UINT ValidateField6()
#endif 
{
uiSeverity=0;
if ((!((M_ISFIELDN(uiCurFieldNo,"F",0,1) && 
IsFormat(uiCurFieldNo,"Cnn") && 
M_STRCMP(M_GETFIELDN(uiCurFieldNo,1,2),"01")>=0 && M_STRCMP(M_GETFIELDN(uiCurFieldNo,1,2),"51")<=0
) || M_ISFIELD(uiCurFieldNo,"F99") || M_ISFIELD(uiCurFieldNo,"XXX"))) && (!IgnoreRule(556))) {
	uiSeverity=99;
	strcpy(RuleText,"CONSPINE must contain a valid code (F01 - F51 or F99) or be XXX.");
	return 556;
	}
if ((!(M_ISFIELD(uiCurFieldNo,"XXX") || M_ISFIELD(_MAXSPINE_,"XXX") ? M_TRUE : GetFieldNoIntegerMid(uiCurFieldNo,1,2) <= GetFieldNoIntegerMid(_MAXSPINE_,1,2))) && (!IgnoreRule(557))) {
	uiSeverity=99;
	strcpy(RuleText,"When not equal to XXX, CONSPINE must be less than or equal to MAXSPINE");
	return 557;
	}
if ((!(M_ISFIELD(_MINSPINE_,"XXX") ? M_ISFIELD(uiCurFieldNo,"XXX") : M_TRUE)) && (!IgnoreRule(558))) {
	uiSeverity=99;
	strcpy(RuleText,"CONSPINE must be XXX if MINSPINE is XXX.");
	return 558;
	}
if ((!(M_ISFIELD(uiCurFieldNo,"XXX") || M_ISFIELD(_MAXSPINE_,"XXX") ? M_TRUE : GetFieldNoIntegerMid(uiCurFieldNo,1,2) >= GetFieldNoIntegerMid(_MINSPINE_,1,2))) && (!IgnoreRule(666))) {
	uiSeverity=99;
	strcpy(RuleText,"CONSPINE must be greater than or equal to MINSPINE.");
	return 666;
	}
return 0;
}

#ifdef ANSI
static UINT FieldInfo7(int bMacro)
#else 
static UINT FieldInfo7(bMacro)
int bMacro;
#endif 
{
if (!bMacro) {	return TRUE;
}
return 0;
}

#ifdef ANSI
static UINT ValidateField7(void)
#else 
static UINT ValidateField7()
#endif 
{
uiSeverity=0;
if ((!(!M_ISFIELD(_MINSPINE_,"XXX") ?  
(
(M_ISFIELDN(uiCurFieldNo,"F",0,1) && 
IsFormat(uiCurFieldNo,"Cnn") && 
M_STRCMP(M_GETFIELDN(uiCurFieldNo,1,2),"01")>=0 && M_STRCMP(M_GETFIELDN(uiCurFieldNo,1,2),"51")<=0)
) || M_ISFIELD(uiCurFieldNo,"F99") : M_TRUE)) && (!IgnoreRule(559))) {
	uiSeverity=99;
	strcpy(RuleText,"If MINSPINE is completed (excluding XXX) MAXSPINE must contain a valid code (F01 - F51, or F99) from the Framework Salary Spine.");
	return 559;
	}
if ((!(M_ISFIELD(_MINSPINE_,"XXX") ? M_ISFIELD(uiCurFieldNo,"XXX") : M_TRUE)) && (!IgnoreRule(561))) {
	uiSeverity=99;
	strcpy(RuleText,"MAXSPINE must be XXX if MINSPINE is XXX");
	return 561;
	}
if ((!(M_ISFIELD(uiCurFieldNo,"XXX") ? M_ISFIELD(_CONSPINE_,"XXX") : M_TRUE)) && (!IgnoreRule(667))) {
	uiSeverity=99;
	strcpy(RuleText,"MAXSPINE must not be XXX if CONSPINE is not XXX");
	return 667;
	}
if ((!(M_ISFIELD(uiCurFieldNo,"XXX") ? M_ISFIELD(_MINSPINE_,"XXX") : M_TRUE)) && (!IgnoreRule(668))) {
	uiSeverity=99;
	strcpy(RuleText,"MAXSPINE must not be XXX if MINSPINE is not XXX");
	return 668;
	}
if ((!(M_ISFIELD(uiCurFieldNo,"XXX") || M_ISFIELD(_MINSPINE_,"XXX") ? M_TRUE : GetFieldNoIntegerMid(uiCurFieldNo,1,2) >= GetFieldNoIntegerMid(_MINSPINE_,1,2))) && (!IgnoreRule(669))) {
	uiSeverity=99;
	strcpy(RuleText,"MAXSPINE must be greater than or equal to MINSPINE");
	return 669;
	}
return 0;
}

#ifdef ANSI
static UINT FieldInfo8(int bMacro)
#else 
static UINT FieldInfo8(bMacro)
int bMacro;
#endif 
{
if (!bMacro) {	return TRUE;
}
return 0;
}

#ifdef ANSI
static UINT ValidateField8(void)
#else 
static UINT ValidateField8()
#endif 
{
uiSeverity=0;
if ((!(IsValidInteger(uiCurFieldNo,0L,9999999L) || M_ISFIELD(uiCurFieldNo,"XXXXXXX"))) && (!IgnoreRule(562))) {
	uiSeverity=99;
	strcpy(RuleText,"MINSAL must be completed with a 7 digit value or be XXXXXXX");
	return 562;
	}
if ((!(M_ISFIELD(uiCurFieldNo,"XXXXXXX") || M_ISFIELD(_MAXSAL_,"XXXXXXX") ? M_TRUE : GetFieldNoDouble(uiCurFieldNo) <= GetFieldNoDouble(_MAXSAL_))) && (!IgnoreRule(650))) {
	uiSeverity=99;
	strcpy(RuleText,"When not equal to XXXXXXX, MINSAL must be less than or equal to MAXSAL");
	return 650;
	}
if ((!(M_ISFIELD(uiCurFieldNo,"XXXXXXX") ? M_TRUE : GetFieldNoDouble(uiCurFieldNo) >= 5000)) && (!IgnoreRule(651))) {
	uiSeverity=9;
	strcpy(RuleText,"MINSAL is less than 5000");
	return 651;
	}
return 0;
}

#ifdef ANSI
static UINT FieldInfo9(int bMacro)
#else 
static UINT FieldInfo9(bMacro)
int bMacro;
#endif 
{
if (!bMacro) {	return TRUE;
}
return 0;
}

#ifdef ANSI
static UINT ValidateField9(void)
#else 
static UINT ValidateField9()
#endif 
{
uiSeverity=0;
if ((!(IsValidInteger(uiCurFieldNo,0L,9999999L) || M_ISFIELD(uiCurFieldNo,"XXXXXXX"))) && (!IgnoreRule(566))) {
	uiSeverity=99;
	strcpy(RuleText,"CONSAL must be completed with a 7 digit value or be XXXXXXX");
	return 566;
	}
if ((!(M_ISFIELD(uiCurFieldNo,"XXXXXXX") || M_ISFIELD(_MAXSAL_,"XXXXXXX") ? M_TRUE : 
GetFieldNoDouble(uiCurFieldNo) <= GetFieldNoDouble(_MAXSAL_))) && (!IgnoreRule(568))) {
	uiSeverity=99;
	strcpy(RuleText,"When not equal to XXXXXXX, CONSAL must be less than or equal to MAXSAL");
	return 568;
	}
if ((!(M_ISFIELD(uiCurFieldNo,"XXXXXXX") || M_ISFIELD(_MAXSAL_,"XXXXXXX") ? M_TRUE : 
GetFieldNoDouble(uiCurFieldNo) >= GetFieldNoDouble(_MINSAL_))) && (!IgnoreRule(670))) {
	uiSeverity=99;
	strcpy(RuleText,"CONSAL must be greater than or equal to MINSAL when MINSAL is not XXXXXXX.");
	return 670;
	}
if ((!(M_ISFIELD(_CONSPINE_,"F99") ? 
!M_ISFIELD(uiCurFieldNo,"XXXXXXX") : M_TRUE)) && (!IgnoreRule(672))) {
	uiSeverity=99;
	strcpy(RuleText,"CONSAL must not be XXXXXXX when CONSPINE is F99");
	return 672;
	}
if ((!(!M_ISFIELD(_CONSPINE_,"F99") && !M_ISFIELD(_CONSPINE_,"XXX") &&
!M_ISFIELD(_MINSAL_,"XXXXXXX") &&
!M_ISFIELD(_MAXSAL_,"XXXXXXX") ? !M_ISFIELD(uiCurFieldNo,"XXXXXXX") : M_TRUE)) && (!IgnoreRule(673))) {
	uiSeverity=99;
	strcpy(RuleText,"CONSAL must not be XXXXXXX when (CONSPINE is not F99 or XXX) and (MINSAL and MAXSAL are not XXXXXXX).");
	return 673;
	}
return 0;
}

#ifdef ANSI
static UINT FieldInfo10(int bMacro)
#else 
static UINT FieldInfo10(bMacro)
int bMacro;
#endif 
{
if (!bMacro) {	return TRUE;
}
return 0;
}

#ifdef ANSI
static UINT ValidateField10(void)
#else 
static UINT ValidateField10()
#endif 
{
uiSeverity=0;
if ((!(IsValidInteger(uiCurFieldNo,0L,9999999L) || M_ISFIELD(uiCurFieldNo,"XXXXXXX"))) && (!IgnoreRule(569))) {
	uiSeverity=99;
	strcpy(RuleText,"MAXSAL must be completed with a 7 digit value or be XXXXXXX");
	return 569;
	}
if ((!(M_ISFIELD(uiCurFieldNo,"XXXXXXX") || M_ISFIELD(_MINSAL_,"XXXXXXX") ? M_TRUE : GetFieldNoDouble(uiCurFieldNo) >= GetFieldNoDouble(_MINSAL_))) && (!IgnoreRule(571))) {
	uiSeverity=99;
	strcpy(RuleText,"MAXSAL must be greater than or equal to MINSAL, except where MINSAL=XXXXXXX.");
	return 571;
	}
if ((!(M_ISFIELD(_MAXSPINE_,"F99") ? 
!M_ISFIELD(uiCurFieldNo,"XXXXXXX") : M_TRUE)) && (!IgnoreRule(674))) {
	uiSeverity=99;
	strcpy(RuleText,"MAXSAL must not be XXXXXXX when MAXSPINE is F99");
	return 674;
	}
if ((!(!M_ISFIELD(_CONSAL_,"XXXXXXX") ? 
!M_ISFIELD(uiCurFieldNo,"XXXXXXX") : M_TRUE)) && (!IgnoreRule(675))) {
	uiSeverity=99;
	strcpy(RuleText,"MAXSAL must not be XXXXXXX when CONSAL is not XXXXXXX");
	return 675;
	}
if ((!(!M_ISFIELD(_MINSAL_,"XXXXXXX") ? 
!M_ISFIELD(uiCurFieldNo,"XXXXXXX") : M_TRUE)) && (!IgnoreRule(676))) {
	uiSeverity=99;
	strcpy(RuleText,"MAXSAL must not be XXXXXXX when MINSAL is not XXXXXXX");
	return 676;
	}
if ((!(M_ISFIELD(uiCurFieldNo,"XXXXXXX") ? M_TRUE : GetFieldNoDouble(uiCurFieldNo) <= 150000)) && (!IgnoreRule(572))) {
	uiSeverity=9;
	strcpy(RuleText,"MAXSAL is greater than 150000");
	return 572;
	}
return 0;
}
